## Python Script "getRecentTasks"
##bind container = container
##bind context = context
##bind namespace = 
##bind script = script
##bind subpath = traverse_subpath
##parameters = batch_size
##Title = Return recent tasks for the timetracker tasks view.

query = {
        'portal_type':'Task',
        'getPending':False,
        'getRunning':False,
        'path':'/'.join(context.getPhysicalPath()),
        'sort_on':'getEndDate',
        'sort_order':'reverse'
    }

start_date = DateTime(DateTime().Date())
end_date = start_date+1
remainder = int(batch_size)
map_list = []

ddict = {
    'Today': {'query': [start_date, end_date], 'range':'minmax'},
    'Yesterday': {'query': [start_date-1, end_date-1], 'range':'minmax'},
    'Older tasks': {'query': [start_date-1], 'range':'max'},
    }

offset = 0
for key in ['Today', 'Yesterday', 'Older tasks']:
    if remainder:
        duration = 0
        query['getEndDate'] = ddict[key]
        ps = context.portal_catalog(query)
        if key != 'Older tasks' and ps:
            for p in ps:
                duration += p.getObject().getDuration() 
            duration = int(duration/60)
            total_hours = int(duration/60)
            total_minutes = int(duration%60)
        else:
            total_hours = 0
            total_minutes = 0
        if len(ps) > remainder:
            ps = ps[:remainder]
        remainder = remainder - len(ps)
        map_list.append((key, ps, offset, total_hours, total_minutes))
        offset += len(ps)
    else:
        map_list.append(('', [], offset, 0, 0))

return map_list

